import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import controlP5.*; 
import java.io.File; 
import java.io.IOException; 
import java.io.BufferedWriter; 
import java.io.FileWriter; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Halo extends PApplet {


ControlP5 controlP5;





//INTERACTIVE VISUALIZATION OF THE PARHELIC CIRCLE, Markus Selmke (selmke@rz.uni-leipzig.de, markus.selmke@gmx.de)

PImage im_1,im_2,im_3,im_4,im_5,im_6,im_7,im_8,im_9;
PImage im_0,im_10,im_20,im_30,im_40,im_50,im_60,im_70,im_80,im_90,im_100,im_110,im_120,im_130,im_140,im_150,im_160,im_170,im_180;
PImage im_90PHmin,im_90PHmax,im375,imL1,imL1max,imL1min,imL2max,imL2min,imPHmax,imPHmin,imBS,im375min;
PImage im_P3d, im_P2d;

public int CSizex=1400,CSizey=600; //canvas size
public float cL,ca,ep,Exposure,rim,gim,bim,b,xRD,yRD,n0,dndcol,nc,dndl,R,PS,xRDn,yRDn,dtheta,theta,theta0,ev,dpsi,psiScale,MaxInt,MinInt,YOffset,YScale,XOffset,LineLength,divergence,yLinScale;
float phiTIR, phi11, phi12, phi21, phi22, phi31, phi32, phi41, phi42, phi03, phiy3, phiz3;
float phi11p, phi12p, phi21p, phi22p, phi31p, phi32p, phi41p, phi42p, phi03p, phiy3p, phiz3p;
public float thetaPHmin,thetaPHmax,theta90PHmax,thetaL1,thetaL1max,thetaL1min,thetaL2min,thetaL2max,theta375,theta1,thetaBS,theta375min;
float n,nRays,nRays1,nRays2,Nb,Nbs,bi,alphaV,Rm,Tm,cosi,cosr,dcol,sqrt3,tan31p,tan11p,cos11,cos31,cos41,tan41p,cos11p,cos31p;
float f,x,y,xp,r11,r12,r31,r32,r41,r42;
float sinec, sinecp, evp;
int k,j,i,thetai,coli;
public int col, colMax, SumLine;
public boolean ToggleI=true, bover=false, locked=false, ToggleDispersion=true, DrawStop=false, ToggleLines=false, LogScale=true, ToggleCardBoard=false, TogglePath132=false, CosToggle=false;
public PFont font, CP5font;

public float[][][] Intensity = new float[3][50][1000];
public float[][][] IntensityCat = new float[3][17][1000];
public float[] DeflectionAngles = new float[50];
public float[] GeometricFactors = new float[50];
public float[] FresnelFactors = new float[50];
public float[] RoundTripThetai = new float[20];
public float[] RoundTripThetaWidthsi = new float[20];

//Path 132
public float[] VerticesX = new float[5];
public float[] VerticesY = new float[5];
public float[] Areas = new float[3];
float r132, r132A1, r132A2, r132A3, phi132A1, phi132A1p, phi132A2, phi132A2p, phi132A3, phi132A3p;

public void setup(){
 size(CSizex,CSizey);
 background(0.1f,0.1f,0.1f,1);
 smooth();
 
 Nbs = 20001; //number of indicent angles
 theta0 = 0.0f; //starting prism angle
 dtheta = (PI/6)/Nbs; //prism orientation increment
 
 n0 = 1.31f;//1.331; //refarctive index
 dndcol = 0.01f/3; //dispersion, i.e. n(col)=n0+dndcol*col, col=0,1,2,3,...
 
 ev = 40.0f*PI/180; //light source elevation
 ca = 1.0f; //c:L = 2*c:a
 divergence = 0.0f; //light source divergence
 dpsi = PI/1000; //azimuth angle bin size
 
 YOffset = 40; //plot offset in y-direction
 YScale = 50; //plot scale
 XOffset = 5; //plot margin in x-direction
 psiScale = (CSizex-2*XOffset)/PI; //plot scale
 LineLength = 15; //length of characteristic angle lines
 yLinScale = 1.0f;
 
 SetIntZero();
  
 //load annotation images 
   im_1 = loadImage("theta1.png"); 
   im_2 = loadImage("theta2.png");
   im_3 = loadImage("theta3.png");
   im_4 = loadImage("theta4.png");
   im_5 = loadImage("theta5.png");
   im_6 = loadImage("theta6.png");
   im_7 = loadImage("theta7.png");
   im_8 = loadImage("theta8.png");
   im_9 = loadImage("theta9.png");
   
   im_0 = loadImage("0.png");
   im_10 = loadImage("10.png");
   im_20 = loadImage("20.png");
   im_30 = loadImage("30.png");
   im_40 = loadImage("40.png");
   im_50 = loadImage("50.png");
   im_60 = loadImage("60.png");
   im_70 = loadImage("70.png");
   im_80 = loadImage("80.png");
   im_90 = loadImage("90.png");
   im_100 = loadImage("100.png");
   im_110 = loadImage("110.png");
   im_120 = loadImage("120.png");
   im_130 = loadImage("130.png");
   im_140 = loadImage("140.png");
   im_150 = loadImage("150.png");
   im_160 = loadImage("160.png");
   im_170 = loadImage("170.png");
   im_180 = loadImage("180.png");
   
   im_90PHmin = loadImage("theta90min.png");
   im_90PHmax = loadImage("theta90max.png");
   im375 = loadImage("theta375.png");
   imL1 = loadImage("thetaL1.png");
   imL1max = loadImage("thetaL1max.png");
   imL1min = loadImage("thetaL1min.png");
   imL2max = loadImage("thetaL2max.png");
   imL2min = loadImage("thetaL2min.png");
   imPHmax = loadImage("thetaPHmax.png");
   imPHmin = loadImage("thetaPHmin.png");
   imBS = loadImage("thetaBS.png");
   im375min = loadImage("theta375min.png");
   
   im_P2d = loadImage("Prism2d.png");
   im_P3d = loadImage("Prism3d.png");
 
 //initialize control sliders and checkboxes
 controlP5 = new ControlP5(this);
   font = createFont("Arial", 12); 
   textFont(font);
   ControlFont CP5font = new ControlFont(font); 
   controlP5.setControlFont(CP5font);
  
 Toggle DispersionToggle = controlP5.addToggle("Dispersion", ToggleDispersion, CSizex - 200, 185, 20, 20);
    DispersionToggle.setValue(true);
    DispersionToggle.captionLabel().toUpperCase(false);
    DispersionToggle.setCaptionLabel("disp.");
    
 Toggle LinesToggle = controlP5.addToggle("Lines", ToggleLines, CSizex - 160, 185, 20, 20);
    LinesToggle.setValue(false);
    LinesToggle.captionLabel().toUpperCase(false);
    LinesToggle.setCaptionLabel("lines");
    
 Toggle LogToggle = controlP5.addToggle("Log", LogScale, CSizex - 120, 185, 20, 20);
    LogToggle.setValue(true);
    LogToggle.captionLabel().toUpperCase(false);
    LogToggle.setCaptionLabel("log");
    
 Toggle CardBoardToggle = controlP5.addToggle("Obstruction", ToggleCardBoard, CSizex - 80, 185, 20, 20);
    CardBoardToggle.setValue(false);
    CardBoardToggle.captionLabel().toUpperCase(false);
    CardBoardToggle.setCaptionLabel("obstruction");
 
 Slider ImpactN = controlP5.addSlider("Nimpactparam", 100, 100000, 20000, CSizex - 200, 60, 100, 20);
   ImpactN.captionLabel().toUpperCase(false);
   ImpactN.setCaptionLabel("# of angles");
   ImpactN.setValue(Nbs);
   
 Slider RefrIndex = controlP5.addSlider("refrindex", 1, 1.8f, 1.31f, CSizex - 200, 85, 100, 20);
   RefrIndex.captionLabel().toUpperCase(false);
   RefrIndex.setCaptionLabel("refractve index");
   
 Slider Elevation = controlP5.addSlider("elevation", 0, 90, 0.0f, CSizex - 200, 110, 100, 20);
   Elevation.captionLabel().toUpperCase(false);
   Elevation.setCaptionLabel("elevation");
   Elevation.setValue(ev*180/PI);
   
 Slider Lightsourcewidth = controlP5.addSlider("sourcewidth", 0, 10, 0.0f, CSizex - 200, 135, 100, 20);
   Lightsourcewidth.captionLabel().toUpperCase(false);
   Lightsourcewidth.setCaptionLabel("divergence");
   
 Slider LinScale = controlP5.addSlider("linscale", 1, 100, 1, CSizex - 200, 160, 100, 20);
   LinScale.captionLabel().toUpperCase(false);
   LinScale.setCaptionLabel("int. scale");
 
 Slider ExposureScale = controlP5.addSlider("exposurescale", 1, 50, 30, 10, CSizey-20, 30, 20);
   ExposureScale.captionLabel().toUpperCase(false);
   ExposureScale.setCaptionLabel(" exposure"); 
   ExposureScale.setValue(30);
  
 Slider caslider = controlP5.addSlider("ca", 0.0001f, 5, 1, 25, 20, 50, 20);
   caslider.captionLabel().toUpperCase(false);
   caslider.setCaptionLabel("c:a"); 
   caslider.setValue(ca);
   //corresponds to (1/2)*(c/L) since a should be the distance across a basal face (W. Tape, "Atmospheric Halos", p. 108), i.e. a=2L
   
 Toggle Path132Toggle = controlP5.addToggle("path132", TogglePath132, 25, 45, 20, 20);
   Path132Toggle.setValue(false);
   Path132Toggle.captionLabel().toUpperCase(false);
   Path132Toggle.setCaptionLabel("1-3-2");
   
 Button ExportButton = controlP5.addButton("Export",1.0f,20,90,70,20);
   ExportButton.captionLabel().toUpperCase(false);
   ExportButton.setCaptionLabel("export data");
   
// Toggle CosineFactorToggle = controlP5.addToggle("cosinetoggle", CosToggle, 25, 200, 20, 20);
//   CosineFactorToggle.setValue(false);
//   CosineFactorToggle.captionLabel().toUpperCase(false);
//   CosineFactorToggle.setCaptionLabel("cos factor");
}

public void Export(int theValue) {
    //IntensityCat[col][0][thetai]: sum of all ray paths (no obstruction)
    //IntensityCat[col][1][thetai]: 3-7 (22\u00b0PH)
    //IntensityCat[col][2][thetai]: 3-5-7-3 (90\u00b0PH)
    //IntensityCat[col][3][thetai]: 3-8-7-5 and 3-5-6-7 (LQPH2)
    //IntensityCat[col][4][thetai]: 3-5-6-7-3 (LQPH1, RT#1)
    //IntensityCat[col][5][thetai]: 3-7-5
    //IntensityCat[col][6][thetai]: 3-8-7
    //IntensityCat[col][7][thetai]: round-trips (excluding those visible with obstruction)
    //IntensityCat[col][8][thetai]: 3-7-4
    //IntensityCat[col][9][thetai]: 3-6-4
    //IntensityCat[col][10][thetai]: 3-5-7-4 and 3-6-8-4 (120\u00b0-PH )
    //IntensityCat[col][11][thetai]: 3 (external reflection)
    //IntensityCat[col][12][thetai]: total intensity for obstruction exp.
    //IntensityCat[col][13][thetai]: round trips visible with obstruction (RT#2, RT#3, ...)
    //IntensityCat[col][14][thetai]: 3-6-3
    //IntensityCat[col][15][thetai]: 1-3-2
    //IntensityCat[col][16][thetai]: 3-8-7-5-3
 try {
          println("Attempting To Save Array Contents To File...");
          BufferedWriter writer = new BufferedWriter(new FileWriter(sketchPath + "/PHC_intensity.txt", false));
          for(int i = 0; i < 1000; i++) {
            for(k=0; k<17; k++) {
              String x = str(IntensityCat[0][k][i]); //use coli=0 (no dispersion), export k-th category 
              writer.write(x);
              writer.write(",");
            }
            String y = str(i*dpsi);
              writer.write(y);
              writer.write(",");
            String z = str(i*dpsi*180/PI);
              writer.write(z);
            writer.newLine();  // More Platform-independent that using write("\n");
          }
          writer.flush();
          writer.close();
          println("Saved Array To File Successfully...");
        } 
        catch (IOException e) {
          println("Couldnt Save Array To File... ");
          e.printStackTrace();
        } 
}

public void ca(float theValue) {
    cL = 2*theValue; //c:L = 2*c:a
    theta0 = 0; //redo evaluation
}

public void refrindex(float theValue) {
    n0 = theValue;
    theta0 = 0; //redo evaluation
}

public void linscale(float theValue) {
    yLinScale = theValue;
}

public void exposurescale(float theValue) {
    Exposure = theValue;
}

public void elevation(float theValue) {
    ev = theValue*PI/180;
    theta0 = 0; //redo evaluation
}

public void sourcewidth(float theValue) {
    divergence = theValue*PI/180;
    theta0 = 0; //redo evaluation
}

public void Nimpactparam(int theValue) {
    dtheta = (PI/6)/theValue;
    theta0 = 0; //redo evaluation
}

public void Dispersion(boolean theFlag) {
  ToggleDispersion=theFlag;
  if (ToggleDispersion==true) {
    colMax = 3; //simulate three colors
  } else {
    colMax = 1; //simulate one color only, i.e. use n0
  }
  theta0 = 0;
}

public void Log(boolean theFlag) {
  LogScale=theFlag;
}

public void path132(boolean theFlag) {
  TogglePath132=theFlag;
  theta0 = 0;
}

public void Obstruction(boolean theFlag) {
  ToggleCardBoard=theFlag;
}

public void Lines(boolean theFlag) {
  ToggleLines=theFlag;
  if (ToggleLines==true) {
    LineLength = CSizey-20;
  } else {
    LineLength = 15;
  }
}

//void cosinetoggle(boolean theFlag) {
//  CosToggle=theFlag;
//  theta0 = 0; //redo evaluation
//}

public void draw(){
  colorMode(RGB, 1,1,1,1);
  ellipseMode(CENTER);
  rectMode(CORNER);
  background(1,1,1,1);
  frame.setTitle("Parhelic Circle Intensity Distribution");
  
  if (TogglePath132==true) {
    image(im_P3d,20,120);
  }
  image(im_P2d,CSizex-330,55);
  
  noStroke(); fill(0.5f,0.5f,0.5f,0.5f);
  rect(CSizex - 205,55,200,170);
  rect(20,15,80,70);
    
  if (theta0>(PI/6 - dtheta)) { 
    DrawStop = true;
  } else {
    DrawStop = false;
    SetIntZero();
  }
  
  if (DrawStop==false) {
    for (col=0; col<colMax; col=col+1) {
      //refractive index for current color
        nc = refractiveindex();
      //effective index of refraction including the effect of finite elevation  
        n = nc*sqrt(1-pow(sin(ev),2)/pow(nc,2))/sqrt(1-pow(sin(ev),2));  
        phiTIR = asin(1/n);
      //get special angles for red
        if (col==0) {
           getAngles(n);
        }
      //Go though prism orientations
      for (theta0=0.0f; theta0<PI/6; theta0=theta0+dtheta) {
        theta = theta0;
        
        //indicent angles on the three considered entry faces for the range of prism orientations
        //notation as in Reference: M. Denny, \u201cCalculation of the 22\u25e6 halo,\u201d Eur. J. Phys. 18, 432\u2013435 (1997).
        phi11 = PI/3 - theta;
        phi31 = theta;
        phi41 = PI/3 + theta;
        
        //refracted angles
        phi11p = asin(sin(phi11)/n);
        phi31p = asin(sin(phi31)/n);
        phi41p = asin(sin(phi41)/n);
        
        //internal angles for second interface (second to next to the entry face)
        phi12p = PI/3 - phi11p; 
        phi32p = PI/3 - phi31p;
        phi42p = PI/3 - phi41p;
        
        //refraced external angle
        phi12 = asin(n*sin(phi12p));
        phi32 = asin(n*sin(phi32p));
        phi42 = asin(n*sin(phi42p));
        
        //total deflection angles
        DeflectionAngles[0] = 0;
        DeflectionAngles[1] = phi12 - theta;
        DeflectionAngles[2] = PI/3 + 2*theta;
        DeflectionAngles[3] = phi32 + theta - PI/3;
        DeflectionAngles[4] = phi42 + theta;
        DeflectionAngles[5] = PI/3 + 2*theta;
        DeflectionAngles[6] = PI/3 - 2*theta;
        DeflectionAngles[7] = PI - 2*theta; 
        DeflectionAngles[8] = PI - 2*theta;
        DeflectionAngles[9] = theta + PI - phi42;
        DeflectionAngles[10] = theta -2*PI/3 - phi32;
        DeflectionAngles[11] = PI + 2*theta;
        DeflectionAngles[12] = PI/3 - 2*theta;
        DeflectionAngles[13] = PI + 2*theta;
        DeflectionAngles[14] = 5*PI/3 - 2*theta;
        DeflectionAngles[15] = 2*theta - PI;
        DeflectionAngles[16] = 7*PI/3 + 2*theta - 2*PI;
        DeflectionAngles[17] = 5*PI/3 + 2*theta;
        DeflectionAngles[18] = PI/3 + 2*theta;
        DeflectionAngles[19] = PI - theta - phi12;
        DeflectionAngles[20] = 4*PI/3 - theta + phi12;
        DeflectionAngles[21] = 4*PI/3 + theta + phi42;
        DeflectionAngles[22] = PI + theta + phi32;
        DeflectionAngles[23] = 9*PI/3 + 2*theta - 2*PI;
        DeflectionAngles[24] = 11*PI/3 + 2*theta - 2*PI;
        DeflectionAngles[25] = 13*PI/3 + 2*theta - 4*PI;
        DeflectionAngles[26] = 2*PI/3 + theta + phi42;
        DeflectionAngles[27] = 2*PI/3 - theta + phi12;
        DeflectionAngles[28] = -PI/3 - theta - phi12;
        DeflectionAngles[29] = 15*PI/3 + 2*theta - 4*PI;
        DeflectionAngles[30] = 17*PI/3 + 2*theta - 4*PI;
        DeflectionAngles[31] = 19*PI/3 + 2*theta - 6*PI;
        DeflectionAngles[32] = 21*PI/3 + 2*theta - 6*PI;
        DeflectionAngles[33] = 23*PI/3 + 2*theta - 6*PI;
        DeflectionAngles[34] = 25*PI/3 + 2*theta - 8*PI;
        DeflectionAngles[35] = 2*PI/3 + 1*random(0.005f);
        DeflectionAngles[36] = 2*PI/3 + 1*random(0.005f);
        DeflectionAngles[37] = 2*PI/3 + 1*random(0.005f);
        DeflectionAngles[38] = 5*PI/3 - 2*theta;
        DeflectionAngles[39] = 5*PI/3 + 2*theta;
        DeflectionAngles[40] = 2*PI/3 - theta + phi12;
        DeflectionAngles[41] = 2*PI/3 + theta + phi42;
        DeflectionAngles[42] = PI/3 + theta + phi32;
        DeflectionAngles[43] = 2*PI/3 + 1*random(0.005f);
        DeflectionAngles[44] = 2*PI/3 + 1*random(0.005f);
        DeflectionAngles[45] = 2*PI/3 + 1*random(0.005f);
        DeflectionAngles[46] = 2*PI/3 + 1*random(0.005f);
        DeflectionAngles[47] = PI/3 + 2*theta; //132, A1
        DeflectionAngles[48] = PI - 2*theta; //132, A2
        DeflectionAngles[49] = PI/3 - 2*theta; //132, A3
        
        //restrict angles to the range [0\u00b0-180\u00b0]
          DeflectionAngleReflection();
      
        //appearing constants
          sqrt3 = sqrt(3); 
          tan31p=tan(phi31p); tan11p=tan(phi11p); tan41p=tan(phi41p);
          cos11=cos(phi11); cos31=cos(phi31); cos41=cos(phi41);
          cos11p=cos(phi11p); cos31p=cos(phi31p);
        
        //geometrical contrains. A single number for each Ray path according to the supplemented map
          f=(1-sqrt3*tan31p)/2;
        GeometricFactors[0]=max(0,f);
          x=(-1+sqrt3*tan11p)/2; x=max(0,x);
          y=1-sqrt3*tan11p; y=max(0,y);
          f=1-x-y; f=min(1,f);
        GeometricFactors[1]=f*cos11/2;
        GeometricFactors[2]=cos11/2;
          f=sqrt3*tan31p*cos31/2;
        GeometricFactors[3]=max(0,f);
          x=(-1+sqrt3*tan41p)/2; x=max(0,x);
          f=1-x; f=f*cos41/2;
        GeometricFactors[4]=max(0,f);
          x=(-1+sqrt3*tan41p)/2; x=max(0,x);
          f=x*cos41/2;
        GeometricFactors[5]=max(0,f);
        GeometricFactors[6]=cos41/2;
          x=(3.0f/2)*(-1+sqrt3*tan11p); x=max(0,x); x=min(1,x);
          y=(-1+3*sqrt3*tan11p)/2; y=max(0,y); y=min(1,y);
          f=y-x; f=f*cos11/2;
        GeometricFactors[7]=max(0,f);
        GeometricFactors[8]=cos31/2;
          //x=-1+sin(PI/6+phi41p)/cos(phi41p); x=max(0,x);
          x=(-1+sqrt3*tan41p)/2; x=max(0,x);
          y=(5-3*sqrt3*tan41p)/2; y=max(0,y);
          f=1-x-y; f=min(1,f); f=f*cos41/2;
        GeometricFactors[9]=f;
          x=1-sqrt3*tan11p; x=max(0,x);
        GeometricFactors[10]=x*cos31/2;
          x=(3.0f/2)*(-1+sqrt3*tan41p); x=max(0,x); x=min(1,x);
          y=(-1+3*sqrt3*tan41p)/2; y=max(0,y); y=min(1,y);
          f=y-x; f=f*cos41/2;
        GeometricFactors[11]=max(0,f);
          x=(sqrt3*tan11p-1)/2;
          f=x*cos11/2;
        GeometricFactors[12]=max(0,f);
          x=(-1+3*sqrt3*tan31p)/2; x=max(0,x);
          y=(-1+5*sqrt3*tan31p)/2; y=max(0,y);
          xp=sqrt3*tan31p; y=min(y,xp); y=min(1,y);
          f=y-x; f=max(0,f); 
        GeometricFactors[13]=f*cos31/2;
          x=(-1+3*sqrt3*tan11p)/2; x=max(0,x);
          y=(-1+5*sqrt3*tan11p)/2; y=max(0,y);
          xp=sqrt3*tan11p; y=min(y,xp); y=min(1,y);
          f=y-x; f=max(0,f);
        GeometricFactors[14]=f*cos11/2;;
          f=(1-2*sqrt3*tan31p)*cos31/2; 
        GeometricFactors[15]=max(0,f);
          x=sqrt3*tan31p;
          xp=(-1+9*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+7*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f);
        GeometricFactors[16]=f*cos31/2;
          x=sqrt3*tan31p;
          xp=(-1+7*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+5*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(f,0);
        GeometricFactors[17]=f*cos31/2;
          x=(3.0f/2)*(-1+sqrt3*tan31p); x=max(0,x); x=min(1,x);
          y=(-1+3*sqrt3*tan31p)/2; y=max(0,y); y=min(1,y);
          f=y-x; f=f*cos31/2;
        GeometricFactors[18]=max(0,f);  
          x=(-1+sqrt3*tan11p)/2; x=max(0,x); x=min(1,x);
          y=(5-3*sqrt3*tan11p)/2; y=max(0,y); y=min(1,y);
          f=1-x-y;
        GeometricFactors[19]=f*cos11/2;
          x=2.0f*(-1+sqrt3*tan11p); x=max(0,x);
          y=-(3.0f/2)*(-1+sqrt3*tan11p); y=max(0,y);
          f=1-x-y; f=f*cos11/2;
        GeometricFactors[20]=max(0,f);
          x=2.0f*(-1+sqrt3*tan41p); x=max(0,x);
          y=-(3.0f/2)*(-1+sqrt3*tan41p); y=max(0,y);
          f=1-x-y; f=f*cos41/2;
        GeometricFactors[21]=max(0,f); 
          x=2.0f*(-1+sqrt3*tan31p); x=max(0,x);
          y=-(3.0f/2)*(-1+sqrt3*tan31p); y=max(0,y);
          f=1-x-y; f=f*cos31/2;
        GeometricFactors[22]=max(0,f);
          x=sqrt3*tan31p;
          xp=(-1+11*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+9*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[23]=f*cos31/2;
          x=sqrt3*tan31p;
          xp=(-1+13*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+11*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[24]=f*cos31/2;
          x=sqrt3*tan31p;
          xp=(-1+15*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+13*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[25]=f*cos31/2;
          xp=(-1+sqrt3*tan41p)/2; xp=max(0,xp); xp=min(1,xp);
          x=(-2+sqrt(3)*tan41p); x=max(0,x); x=min(1,x);
          f=xp-x; f=f*cos41/2;
        GeometricFactors[26]=max(0,f);
          xp=(-1+sqrt3*tan11p)/2; xp=max(0,xp); xp=min(1,xp);
          x=(-2+sqrt(3)*tan11p); x=max(0,x); x=min(1,x);
          f=xp-x; f=f*cos11/2;
        GeometricFactors[27]=max(0,f);
          x=1-sqrt3*tan11p; x=max(0,x);
          f=x*cos11/2;
        GeometricFactors[28]=max(0,f);  
          x=sqrt3*tan31p;
          xp=(-1+17*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+15*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[29]=f*cos31/2;
          x=sqrt3*tan31p;
          xp=(-1+19*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+17*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[30]=f*cos31/2;
          x=sqrt3*tan31p;
          xp=(-1+21*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+19*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[31]=f*cos31/2;
          x=sqrt3*tan31p;
          xp=(-1+23*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+21*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[32]=f*cos31/2;
          x=sqrt3*tan31p;
          xp=(-1+25*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+23*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[33]=f*cos31/2;
          x=sqrt3*tan31p;
          xp=(-1+27*sqrt3*tan31p)/2; x=min(x,xp); x=max(0,x);
          y=(-1+25*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); 
        GeometricFactors[34]=f*cos31/2;
          x=(3.0f/2)*(1-sqrt3*tan11p); x=min(1,x); x=max(0,x);
          y=(5.0f/2)*(1-sqrt3*tan11p); y=min(1,y); y=max(0,y);
          f=y-x; f=max(0,f);
        GeometricFactors[35]=f*cos11/2;  
          x=(3.0f/2)*(1-sqrt3*tan31p); x=min(1,x); x=max(0,x);
          y=(5.0f/2)*(1-sqrt3*tan31p); y=min(1,y); y=max(0,y);
          f=y-x; f=max(0,f);
        GeometricFactors[36]=f*cos31/2;
          x=(3.0f/2)*(1-sqrt3*tan41p); x=min(1,x); x=max(0,x);
          y=(5.0f/2)*(1-sqrt3*tan41p); y=min(1,y); y=max(0,y);
          f=y-x; f=max(0,f);
        GeometricFactors[37]=f*cos41/2;
        GeometricFactors[38]=GeometricFactors[27];
        GeometricFactors[39]=GeometricFactors[26];
          x=1-sqrt3*tan11p; x=max(0,x);
          xp=1-2*sqrt3*tan11p; xp=max(0,xp);
          x=max(x,xp); x=min(1,x);
          y=(3.0f/2)*(1-sqrt3*tan11p); y=max(0,y); y=min(1,y);
          f=y-x; f=max(0,f); f=min(1,f);
        GeometricFactors[40]=f*cos11/2;
          x=1-sqrt3*tan41p; x=max(0,x);
          xp=1-2*sqrt3*tan41p; xp=max(0,xp);
          x=max(x,xp); x=min(1,x);
          y=(3.0f/2)*(1-sqrt3*tan41p); y=max(0,y); y=min(1,y);
          f=y-x; f=max(0,f); f=min(1,f);
        GeometricFactors[41]=f*cos41/2;
          x=1-sqrt3*tan31p; x=max(0,x);
          xp=1-2*sqrt3*tan31p; xp=max(0,xp);
          x=max(x,xp); x=min(1,x);
          y=(3.0f/2)*(1-sqrt3*tan31p); y=max(0,y); y=min(1,y);
          f=y-x; f=max(0,f); f=min(1,f);
        GeometricFactors[42]=f*cos31/2;
          x=1-sqrt3*tan11p; x=max(0,x);
          y=(3-5*sqrt3*tan11p)/2; y=max(0,y);
          f=x-y; f=max(0,f); f=min(1,f);
        GeometricFactors[43]=f*cos11/2.0f;
          x=1-sqrt3*tan31p; x=max(0,x);
          y=(3-5*sqrt3*tan31p)/2; y=max(0,y);
          f=x-y; f=max(0,f); f=min(1,f);
        GeometricFactors[44]=f*cos31/2.0f;
        GeometricFactors[45]=GeometricFactors[17];
        GeometricFactors[46]=GeometricFactors[16];
  
      //convert projected 2D in-plane to incidence plane angles for correct Fresnel coefs.
      if (ToggleI==true) {
        sinec = sin(PI/2-ev); //ev is the external elevation angle (e.g. solar elevation)
        evp = asin(sin(ev)/nc); //evp is the internal elevation angle
        sinecp = sin(PI/2-evp);
        phi11p = acos(cos(phi11p)*sinecp); phi11 = acos(cos11*sinec);
        phi31p = acos(cos(phi31p)*sinecp); phi31 = acos(cos31*sinec);
        phi41p = acos(cos(phi41p)*sinecp); phi41 = acos(cos41*sinec);
      };
      
      //Fresnel Coefs:
        r11=(pow(sin(phi11-phi11p),2)/pow(sin(phi11+phi11p),2) + pow(tan(phi11-phi11p),2)/pow(tan(phi11+phi11p),2))/2;
        r31=(pow(abs(sin(phi31-phi31p)),2)/pow(abs(sin(phi31+phi31p)),2) + pow(abs(tan(phi31-phi31p)),2)/pow(abs(tan(phi31+phi31p)),2))/2;
        //r31=abs(1/sin(phi31+phi31p));// + pow(tan(phi31-phi31p),2)/pow(tan(phi31+phi31p),2))/2;
        r41=(pow(sin(phi41-phi41p),2)/pow(sin(phi41+phi41p),2) + pow(tan(phi41-phi41p),2)/pow(tan(phi41+phi41p),2))/2;
        //check for NaN:
        if(r31 != r31) {
          r31=0;
        }
      //check for total internal reflection
        if (phi32p>phiTIR) {
          r32 = 1;
        } else {
          r32=(pow(sin(phi32-phi32p),2)/pow(sin(phi32+phi32p),2) + pow(tan(phi32-phi32p),2)/pow(tan(phi32+phi32p),2))/2;
        }
        if (phi12p>phiTIR) {
          r12 = 1;
        } else {
          r12=(pow(sin(phi12-phi12p),2)/pow(sin(phi12+phi12p),2) + pow(tan(phi12-phi12p),2)/pow(tan(phi12+phi12p),2))/2; 
        }
        if (phi42p>phiTIR) {
          r42 = 1;
        } else {
          r42=(pow(sin(phi42-phi42p),2)/pow(sin(phi42+phi42p),2) + pow(tan(phi42-phi42p),2)/pow(tan(phi42+phi42p),2))/2; 
        }
      //Fresnel factors for each ray, i.e. product of Fresnel coefs for each face encountered 
        FresnelFactors[0]=pow(1-r31,2);
        FresnelFactors[1]=(1-r11)*(1-r12);
        FresnelFactors[2]=r11;
        FresnelFactors[3]=(1-r31)*(1-r32);
        FresnelFactors[4]=(1-r41)*(1-r42);
        FresnelFactors[5]=pow(1-r41,2);
        FresnelFactors[6]=r41;
        FresnelFactors[7]=pow(1-r11,2)*r12;
        FresnelFactors[8]=r31;
        FresnelFactors[9]=(1-r41)*r42*(1-r42);
        FresnelFactors[10]=(1-r31)*r31*(1-r32);
        FresnelFactors[11]=pow(1-r41,2)*r42;
        FresnelFactors[12]=pow(1-r11,2);
        FresnelFactors[13]=pow(1-r31,2)*pow(r32,2)*1;
        FresnelFactors[14]=pow(1-r11,2)*pow(r12,2)*1;
        FresnelFactors[15]=pow(1-r31,2)*r31;
        FresnelFactors[16]=(1-r31)*r32*1*(1-r31);
        FresnelFactors[17]=(1-r31)*r32*1*(1-r31);// FresnelFactors[17]=1;
        FresnelFactors[18]=pow(1-r31,2)*r32;  
        FresnelFactors[19]=(1-r11)*r12*(1-r12);
        FresnelFactors[20]=(1-r11)*r12*r11*(1-r12);
        FresnelFactors[21]=(1-r41)*r42*r41*(1-r42);
        FresnelFactors[22]=(1-r31)*r32*r31*(1-r32);
        FresnelFactors[23]=FresnelFactors[16]; 
        FresnelFactors[24]=FresnelFactors[16]; 
        FresnelFactors[25]=FresnelFactors[16]; 
        FresnelFactors[29]=FresnelFactors[16];
        FresnelFactors[30]=FresnelFactors[16];
        FresnelFactors[31]=FresnelFactors[16];
        FresnelFactors[32]=FresnelFactors[16];
        FresnelFactors[33]=FresnelFactors[16];
        FresnelFactors[34]=FresnelFactors[16];
        FresnelFactors[26]=(1-r41)*r41*(1-r42);
        FresnelFactors[27]=(1-r11)*r11*(1-r12);
        FresnelFactors[28]=(1-r11)*r11*(1-r12);
        FresnelFactors[35]=(1-r11)*r12*r11*(1-r11);
        FresnelFactors[36]=(1-r31)*r32*r31*(1-r31);
        FresnelFactors[37]=(1-r41)*r42*r41*(1-r41);
        FresnelFactors[38]=(1-r11)*r11*r12*(1-r11);
        FresnelFactors[39]=(1-r41)*r41*r42*(1-r41);
        FresnelFactors[40]=(1-r11)*r12*1*(1-r12);
        FresnelFactors[41]=(1-r41)*r42*1*(1-r42);
        FresnelFactors[42]=(1-r31)*r32*1*(1-r32);
        FresnelFactors[43]=(1-r11)*r11*r12*(1-r11);
        FresnelFactors[44]=(1-r31)*r31*r32*(1-r31);
        FresnelFactors[45]=(1-r31)*r32*1*r31*(1-r31);
        FresnelFactors[46]=(1-r31)*r32*1*r31*(1-r31);
        
        //132
        if (TogglePath132==true) {
          //now also include the projection of the effective areas with respect to the solar elevation
            Include132();
          //now get 132 path
            pis(cL,theta,nc); //also gets ep
          //get Fresnel coefs for 132 
          r132 = (pow(sin(ep-ev),2)/pow(sin(PI-ev-ep),2) + pow(tan(ep-ev),2)/pow(tan(PI-ev-ep),2))/2;
          phi132A1 = acos(cos(ev)*cos(phi11)/nc); phi132A1p=asin(nc*sin(phi132A1));
          phi132A2 = acos(cos(ev)*cos(phi31)/nc); phi132A2p=asin(nc*sin(phi132A2));
          phi132A3 = acos(cos(ev)*cos(phi41)/nc); phi132A3p=asin(nc*sin(phi132A3));
          if (phi132A1 > asin(1/nc)) {
            r132A1 = 1;
          } else {
            r132A1 = (pow(sin(phi132A1-phi132A1p),2)/pow(sin(phi132A1+phi132A1p),2) + pow(tan(phi132A1-phi132A1p),2)/pow(tan(phi132A1+phi132A1p),2))/2;
          }
          if (phi132A2 > asin(1/nc)) {
            r132A2 = 1;
          } else {
            r132A2 = (pow(sin(phi132A2-phi132A2p),2)/pow(sin(phi132A2+phi132A2p),2) + pow(tan(phi132A2-phi132A2p),2)/pow(tan(phi132A2+phi132A2p),2))/2;
          }
          if (phi132A3 > asin(1/nc)) {
            r132A3 = 1;
          } else {
            r132A3 = (pow(sin(phi132A3-phi132A3p),2)/pow(sin(phi132A3+phi132A3p),2) + pow(tan(phi132A3-phi132A3p),2)/pow(tan(phi132A3+phi132A3p),2))/2;
          }
          GeometricFactors[47] = Areas[0]*sin(ev)/2;
            FresnelFactors[47] = r132A1*pow(1-r132,2);
          GeometricFactors[48] = Areas[1]*sin(ev)/2;
            FresnelFactors[48] = r132A2*pow(1-r132,2);
          GeometricFactors[49] = Areas[2]*sin(ev)/2;
            FresnelFactors[49] = r132A3*pow(1-r132,2);
        }
        //add to total intensities, i.e. do binning
          Intensities();
      }
      //sort into categories/types, i.e. group all paths belonging to 3-7 (22\u00b0PH), 3-5-7-3 (90\u00b0PH), ...
        GetCat();
      //get maximum intensity of the sum for plotting purposes
        GetMax();
    }
  }
  
  if (ToggleI==false) {
    fill(0,0,0,1); text("no incidence plane correction for Fresnel coefs.",150,60);
  };
      
  //DRAW total intensity
  strokeWeight(2); //total intensity
  if (ToggleCardBoard==true) {
    SumLine = 12;
  } else {
    SumLine = 0;
  }
  if (ToggleDispersion==true) {
    DrawLine(0,SumLine,1,0,0,0.1f);
    DrawLine(1,SumLine,0,1,0,0.1f);
    DrawLine(2,SumLine,0,0,1,0.1f); 
  } else {
    DrawLine(0,SumLine,0,0,0,0.1f);
  }
  //Draw individual contributions, grouped
  strokeWeight(1); //individual ones, grouped into types
    DrawLine(0,11,1,1,1,0.1f); //external reflection
    DrawLine(0,2,1,0,0.5f,0.1f); //90\u00b0PH, 3573
    DrawLine(0,4,0.14f,0.62f,0.86f,0.1f); //35673, LQPH1
    DrawLine(0,13,0.21f,0.77f,0.97f,0.1f); //round-trips
    DrawLine(0,16,0.7f,0,0,0.2f); //38753
    //DrawLineIndiv(0,14,0.2,0.2,0.2,0.1); //like external reflection
    //DrawLineIndiv(0,7,0.2,0.2,0.2,0.5); //like external reflection
    if (ToggleCardBoard==false) { //Only visible whithout obstruction:
      DrawLine(0,7,0.21f,0.77f,0.97f,0.1f); //round-trips
      DrawLine(0,1,1,0,0,0.1f); //22\u00b0PH
      DrawLine(0,3,0.95f,0.86f,0.26f,0.3f); //3875, LQ2
      DrawLine(0,5,0.18f,0.87f,0.78f,0.1f); //375
      DrawLine(0,6,1,0.5f,0,0.1f); //387  
      DrawLine(0,8,0,0.5f,0,0.1f); //374
      DrawLine(0,9,0,0.3f,0,0.1f); //364
      DrawLine(0,10,1,1,1,0.1f); //120\u00b0  
    }
    if (TogglePath132==true) {
      DrawLine(0,15,0,0,1,0.2f); //132
    }
    
  //Draw Axis  
    //x-axis
    noStroke(); fill(1,1,1,0.5f);
    rect(0,CSizey-60,CSizex,40);
    strokeWeight(1); stroke(0,0,0,1);  
    for (i=0; i<=18; i++) {
        line(XOffset+i*(PI/18)*psiScale,0,XOffset+i*(PI/18)*psiScale,10);
        line(XOffset+i*(PI/18)*psiScale,CSizey-20,XOffset+i*(PI/18)*psiScale,CSizey-30);
    }
    //y-axis (logarithmic)
    for (i=0; i<=10; i++) {
      for (j=1; j<=9; j++) {
        line(0,YOffsetV()-axisScale(j*MaxInt/pow(10,i)),20+10*signum(1-1.0f*j),YOffsetV()-axisScale(j*MaxInt/pow(10,i)));
      } 
    }
    //y-axis caption (angles, 0\u00b0, 20\u00b0, 40\u00b0, ..., 180\u00b0)
    image(im_0, XOffset-4+0*(PI/18)*psiScale,CSizey-55);
    image(im_20, XOffset-8+2*(PI/18)*psiScale,CSizey-55);
    image(im_40, XOffset-8+4*(PI/18)*psiScale,CSizey-55);
    image(im_60, XOffset-8+6*(PI/18)*psiScale,CSizey-55);
    image(im_80, XOffset-8+8*(PI/18)*psiScale,CSizey-55);
    image(im_100, XOffset-14+10*(PI/18)*psiScale,CSizey-55);
    image(im_120, XOffset-14+12*(PI/18)*psiScale,CSizey-55);
    image(im_140, XOffset-14+14*(PI/18)*psiScale,CSizey-55);
    image(im_160, XOffset-14+16*(PI/18)*psiScale,CSizey-55);
    image(im_180, XOffset-37+18*(PI/18)*psiScale,CSizey-55);
  
  //Special angles annotation in the top scale
    if (TogglePath132==true) {
      //Blue Spot
      stroke(0,0,1,1);
      line(XOffset+thetaBS*psiScale,0,XOffset+thetaBS*psiScale,LineLength);
      image(imBS, XOffset+thetaBS*psiScale, 12);
    }
    //22\u00b0PH
      stroke(1,0,0,1);
      line(XOffset+thetaPHmin*psiScale,0,XOffset+thetaPHmin*psiScale,LineLength);
      image(im_90PHmin, XOffset+thetaPHmin*psiScale, 10);
      noStroke(); fill(1,0,0,0.2f);
      rect(XOffset+thetaPHmin*psiScale,0,(thetaPHmax-thetaPHmin)*psiScale,8);
    //90\u00b0PH
      stroke(1,0,0.5f,1);
      line(XOffset+theta90PHmax*psiScale,0,XOffset+theta90PHmax*psiScale,LineLength);
      image(im_90PHmax, XOffset+theta90PHmax*psiScale, 12);
    //L1
      stroke(0.14f,0.62f,0.86f,1);
      line(XOffset+thetaL1*psiScale,0,XOffset+thetaL1*psiScale,LineLength);
      line(XOffset+thetaL1max*psiScale,0,XOffset+thetaL1max*psiScale,LineLength);
    //image(imL1max, XOffset+thetaL1max*psiScale, 12); 
      noStroke(); fill(0.14f,0.62f,0.86f,0.2f);
      rect(XOffset+thetaL1min*psiScale,0,(thetaL1max-thetaL1min)*psiScale,8);
    //L2
      stroke(0.95f,0.86f,0.26f,1);
      line(XOffset+thetaL2min*psiScale,0,XOffset+thetaL2min*psiScale,LineLength);
      line(XOffset+thetaL2max*psiScale,0,XOffset+thetaL2max*psiScale,LineLength);
      noStroke(); fill(0.95f,0.86f,0.26f,0.4f);
      rect(XOffset+thetaL2min*psiScale,8,(thetaL2max-thetaL2min)*psiScale,16);
      image(imL2min, XOffset+thetaL2min*psiScale, 10);
      image(imL2max, XOffset+thetaL2max*psiScale, 12);
      image(imL1, XOffset+thetaL1*psiScale, 12);
    //375
      stroke(0.18f,0.87f,0.78f,1);
      line(XOffset+theta375*psiScale,0,XOffset+theta375*psiScale,LineLength);
      image(im375, XOffset+theta375*psiScale, 12);
      
      line(XOffset+theta375min*psiScale,0,XOffset+theta375min*psiScale,LineLength);
      image(im375min, XOffset+theta375min*psiScale, 12);
    
  //number paths
  DrawAnnotationNumber(4,RoundTripThetai[1],-20,"3-5-6-7-3 (RT#1)");
  for (k=2; k<13; k++) {
    if (k==4 || k==7 || k==10) {
      String RTstr = "RT#"; RTstr = RTstr + str(k); 
      DrawAnnotationNumber(7,RoundTripThetai[k],5*k,RTstr);
    }  
  }
  DrawAnnotationNumber(14,165*PI/180,50,"3-6-3"); //3-6-3
  DrawAnnotationNumber(2,theta90PHmax,-50,"3-5-7-3"); //90\u00b0PH
  DrawAnnotationNumber(11,10*PI/180,-30,"3"); //external reflections
  DrawAnnotationNumber(16,15*PI/180,150,"3-8-7-5-3"); //3-8-7-5-3
  if (ToggleCardBoard==false) { //Only visible whithout obstruction:
    DrawAnnotationNumber(1,(thetaPHmin+thetaPHmax)/2,-100,"3-7");
    DrawAnnotationNumber(10,120*PI/180,-100,"3-5-7-4"); //120\u00b0PH
    DrawAnnotationNumber(10,120*PI/180,-90,"3-6-8-4"); //120\u00b0PH
    DrawAnnotationNumber(5,140*PI/180,0,"3-7-5");
    DrawAnnotationNumber(6,100*PI/180,-30,"3-8-7");
    DrawAnnotationNumber(8,147*PI/180,230,"3-7-4");
    DrawAnnotationNumber(9,150*PI/180,260,"3-6-4");
    DrawAnnotationNumber(3,(thetaL2min+thetaL2max)/2,0,"3-8-7-5");
    DrawAnnotationNumber(3,(thetaL2min+thetaL2max)/2,10,"3-5-6-7");
    for (k=2; k<13; k++) {
      if (k!=4 && k!=7 && k!=10) {
        String RTstr = "RT#"; RTstr = RTstr + str(k); 
        DrawAnnotationNumber(7,RoundTripThetai[k],5*k,RTstr);
      }  
    }
  }
  
  //Draw image
    DrawImage();
}

public void DeflectionAngleReflection() {
  for (k=0; k<50; k++) {
    DeflectionAngles[k] += divergence*randomNormal();
    DeflectionAngles[k] = abs(DeflectionAngles[k]);
    //DeflectionAngles[k] = DeflectionAngles[k] % (2*PI);
    if (DeflectionAngles[k] >= PI) {
      DeflectionAngles[k] = 2*PI - DeflectionAngles[k];
    }
  }
}

public void Include132() { //side face projection to solar elevation incidence, i.e. excluding 132 path
  for (int k=0; k<47; k++) {
    GeometricFactors[k] = GeometricFactors[k]*cL*cos(ev);
  }
}

public void SetIntZero() {
  for (int coli=0; coli<colMax; coli++) {
    for (int k=0; k<50; k++) {
       for (int i=0; i<1000; i++) {
          Intensity[coli][k][i]=0.000000000001f;
       }
    }
  }
  for (int k=0; k<50; k++) {
    DeflectionAngles[k]=0;
    GeometricFactors[k]=0;
    FresnelFactors[k]=0;
  }
  for (int coli=0; coli<colMax; coli++) {
    for (int k=0; k<17;k++) {
       for (int i=0; i<1000; i++) {
          IntensityCat[coli][k][i]=0.000000000001f;
       }
    }
  }
}

public void Intensities() {
  for (k=0; k<50; k++) {
    thetai = round(DeflectionAngles[k]/dpsi);
    if ((thetai >= 0) && (thetai < 1000)) {
      Intensity[col][k][thetai] += FresnelFactors[k]*GeometricFactors[k];
    }
  }
}

public void GetCat() {
  for (thetai=0; thetai<1000; thetai++) {
    IntensityCat[col][0][thetai] = 0;
    for (k=0; k<50; k++) {
      IntensityCat[col][0][thetai] = IntensityCat[col][0][thetai] + Intensity[col][k][thetai]; //sum
    }
    IntensityCat[col][1][thetai] = Intensity[col][1][thetai]+Intensity[col][3][thetai]+Intensity[col][4][thetai]; //22\u00b0PH
    IntensityCat[col][2][thetai] = Intensity[col][20][thetai]+Intensity[col][21][thetai]+Intensity[col][22][thetai]; //90\u00b0PH
    IntensityCat[col][3][thetai] = Intensity[col][26][thetai]+Intensity[col][27][thetai]+Intensity[col][40][thetai]+Intensity[col][41][thetai]+Intensity[col][42][thetai]; //3875 and 3-5-6-7, LQPH2
    IntensityCat[col][4][thetai] = Intensity[col][13][thetai]+Intensity[col][14][thetai]; //35673, LQPH1
    IntensityCat[col][5][thetai] = Intensity[col][7][thetai]+Intensity[col][11][thetai]+Intensity[col][18][thetai]; //375
    IntensityCat[col][6][thetai] = Intensity[col][5][thetai]+Intensity[col][12][thetai]; //387
    IntensityCat[col][7][thetai] = Intensity[col][16][thetai]+Intensity[col][17][thetai]+Intensity[col][24][thetai]+Intensity[col][25][thetai]; //round-trips (excluding those visible with obstruction)
      IntensityCat[col][7][thetai] = IntensityCat[col][7][thetai] +Intensity[col][30][thetai]+Intensity[col][31][thetai]+Intensity[col][33][thetai]+Intensity[col][34][thetai];
    IntensityCat[col][8][thetai] = Intensity[col][9][thetai]+Intensity[col][19][thetai]; //374
    IntensityCat[col][9][thetai] = Intensity[col][10][thetai]+Intensity[col][28][thetai]; //364
    IntensityCat[col][10][thetai] = Intensity[col][35][thetai]+Intensity[col][36][thetai]+Intensity[col][37][thetai]+Intensity[col][43][thetai]+Intensity[col][44][thetai]+Intensity[col][45][thetai]+Intensity[col][46][thetai]; //120\u00b0
    IntensityCat[col][11][thetai] = Intensity[col][2][thetai]+Intensity[col][6][thetai]+Intensity[col][8][thetai]; //external reflection
    //Cardboard: All faces covered except for two opposing faces
    IntensityCat[col][12][thetai] = Intensity[col][2][thetai]+Intensity[col][20][thetai]+Intensity[col][6][thetai]+Intensity[col][21][thetai]; //total intensity for obstruction exp.
      IntensityCat[col][12][thetai] += Intensity[col][8][thetai]+Intensity[col][15][thetai]+Intensity[col][22][thetai];
      IntensityCat[col][12][thetai] += Intensity[col][13][thetai]+Intensity[col][14][thetai]+Intensity[col][23][thetai]+Intensity[col][29][thetai]+Intensity[col][32][thetai];
    IntensityCat[col][13][thetai] = Intensity[col][23][thetai]+Intensity[col][29][thetai]+Intensity[col][32][thetai]; //round trips visible with obstruction
    IntensityCat[col][14][thetai] = Intensity[col][15][thetai]; //3-6-3
    IntensityCat[col][15][thetai] = Intensity[col][47][thetai] + Intensity[col][48][thetai] + Intensity[col][49][thetai]; //132
    IntensityCat[col][16][thetai] = Intensity[col][38][thetai] + Intensity[col][39][thetai]; //3-8-7-5-3
  } 
}

public void GetMax() {
  MaxInt = 0;
  for (thetai=0; thetai<1000; thetai++) {
     if (IntensityCat[col][0][thetai] > MaxInt) {
         MaxInt = IntensityCat[col][0][thetai];
     }
  }
  MinInt = MaxInt/10000;
}

public float signum(float f) {
  if (f > 0) return 1.0f;
  if (f < 0) return -1.0f;
  return 0;
}

//Draw categorized contribution k for color coli with with line-style [r,g,b,a]
public void DrawLine(int coli, int k, float r, float g, float b, float a) {
  beginShape();
  stroke(r,g,b,1); fill(r,g,b,a);
  vertex(XOffset,YOffsetV()+YScale*50);
  for (i=1; i<1000; i++) {
    vertex(XOffset+i*dpsi*psiScale,YOffsetV()-axisScale(IntensityCat[coli][k][i]));
  }
  vertex(XOffset+i*dpsi*psiScale,YOffsetV()+YScale*50);
  endShape();
}

public void DrawImage() {
  float scal = Exposure*0.0005f/MinInt, exponent = 1/2.4f;
  int ImageCat = 0;
  strokeWeight(3);
  if (ToggleCardBoard==true) {
    ImageCat = 12;
  }
  if (ToggleDispersion==true) {
    for (i=0; i<1000; i++) {
      rim = pow(scal*IntensityCat[0][ImageCat][i],exponent);
      gim = pow(scal*IntensityCat[1][ImageCat][i],exponent);
      bim = pow(scal*IntensityCat[2][ImageCat][i],exponent);
      stroke(rim,gim,bim,1);
      line(XOffset+i*dpsi*psiScale,CSizey-20,XOffset+i*dpsi*psiScale,CSizey);
    }
  } else {
    for (i=0; i<1000; i++) {
      rim = pow(scal*IntensityCat[0][ImageCat][i],exponent);
      stroke(rim,rim,rim,1);
      line(XOffset+i*dpsi*psiScale,CSizey-20,XOffset+i*dpsi*psiScale,CSizey);
    }
  }
}

//Draw uncategorized contribution
public void DrawLineIndiv(int coli, int k, float r, float g, float b, float a) {
  beginShape();
  stroke(r,g,b,1); fill(r,g,b,a);
  for (i=0; i<(1000-1); i++) {
      vertex(XOffset+i*dpsi*psiScale,YOffsetV()-axisScale(Intensity[coli][k][i]));
  }
  endShape();
}

//Draw annotation at angle theta for contribution k using the caption str
public void DrawAnnotationNumber(int k, float theta, int Yoffset, String str) {
  stroke(0.7f,0,0,1); fill(0.7f,0,0,1);
  int YposAnnot = 270 + Yoffset;
  thetai = round(theta/dpsi);
  if (thetai < 1000) {
    line(XOffset+theta*psiScale,YOffsetV()-axisScale(IntensityCat[0][k][round(theta/dpsi)]),XOffset+theta*psiScale,YposAnnot);
  }
  text(str,XOffset+theta*psiScale,YposAnnot - 5);
}

public float axisScale(float val) {
  if (LogScale==true) {
    return (1/(0.01f*yLinScale+0.99f))*YScale*log(val/MaxInt);
  } else {
    return 10*yLinScale*YScale*(val/MaxInt);
  }
}

public float YOffsetV() {
  if (LogScale==true) {
    return YOffset;
  } else {
    return CSizey-YOffset;
  }
}

// return a random value in the range [-1..1] with normal distribution around 0.
// Implements the Marsaglia Polar Method, as described in wikipedia, but only returns one of the values.
public float randomNormal()
{
  float x = 1.0f, y = 1.0f, 
        s = 2.0f; // s = x^2 + y^2
  while(s >= 1.0f)
  {
    x = random(-1.0f, 1.0f);
    y = random(-1.0f, 1.0f);
    s = x*x + y*y;
  }
  return x * sqrt(-2.0f * log(s)/s);
}

//refractive index with dispersion
public float refractiveindex() {
  return n0 + dndcol*col;
}

//compute chartacteristic angles (azimuths)
public void getAngles(float n) {
  int i;
  thetaPHmin = 2*asin(n*sin(PI/6)) - PI/3;
  thetaPHmax = PI/2 - PI/3 + asin(n*sin(PI/3-asin(1/n)));
  theta90PHmax = 2*PI/3-thetaPHmin;
  thetaL1min = 2*acos(n/2);
  thetaL1max = min(2*acos(n/(2*sqrt(19))),PI);
  thetaL1 = 2*acos(n*sin(PI/3-asin(1/n)));
  thetaL2min = PI/3 + 2*asin(n/2);
  //thetaL2max = min(5*PI/6+asin(n*cos(PI/6+asin(1/n))),PI);
  thetaL2max = min(5*PI/6+asin(n*sin(PI/3-asin(1/n))),PI);
  theta375 = PI/3+2*asin(n*sin(PI/3-asin(1/n)));
  //thetaL1 = -theta375+4*PI/3;
  for (i=1; i<20; i=i+1) {
      RoundTripThetai[i] = RoundTripAngle(i,n);
      RoundTripThetaWidthsi[i] = RoundTripWidth(i,n);
  }
  thetaBS = 2*asin(nc*cos(asin(1/nc))/cos(ev));
  theta375min = PI/3 + 2*asin(n/(2*sqrt(7)));
}

//characteristic round trip angles
public float RoundTripAngle(int i, float n) {
  float x = 2.0f*i + 1;
  float angle = PI*x/3 + 2*asin(n/sqrt(1+3*pow(x,2)));
  
  angle = angle % (2*PI);
  if (angle > PI) {
    angle = 2*PI - angle;
  }
  return angle;
}

//characteristic widths
public float RoundTripWidth(int i, float n) {
  float x = 2.0f*i + 1;
  float thetawidthi = (4*n/sqrt(3))*(2/pow(x,2) + (7+pow(n,2)/3)/pow(x,4));
  
  return thetawidthi;
}


//Path 132
//characteristic widths
public float pis(float cL, float delta, float nc) {
  float cosd = cos(delta), sind = sin(delta), sqrt3 = sqrt(3);
  float cos2d = cos(2*delta), sin2d = sin(2*delta);
  float cos3d = cos(3*delta), sin3d = sin(3*delta);
  float cos4d = cos(4*delta), sin4d = sin(4*delta);
  ep = acos(cos(ev)/nc);
  float xp = cL/tan(ep), x, x2;
  
    x = Px(1,delta)+xp;
  float p1x = (4*cosd-cos3d-2*sqrt3*sind+4*x*sin2d+sqrt3*(2*x+sin3d))/(4*sqrt3);
  float p1y = -(-7-3*cos2d+cos4d+2*x*(-1+2*cos2d)*(sqrt3*cosd+sind)-3*sqrt3*sin2d+sqrt3*sin4d)/(4*(3*cosd+sqrt3*sind));
  float p2x = (3*x+4*sqrt3*cosd-3*x*cos2d-sqrt3*cos3d-6*sind+sqrt3*x*sin2d)/6;
  float p2y = (-2*cosd*(-3+sqrt3*x*cosd+3*x*sind)-sqrt3*(-2*sind+sin3d))/6;
  float p3x = -sqrt3*cosd/2+sqrt3/cosd-sind/2;
  float p3y = (cosd-sqrt3*sind)/2;
  float p4x = -(-2*sqrt3+sqrt3*cos2d+sin2d)/(2*(cosd+sqrt3*sind));
  float p4y = (-cosd-sqrt3*sind)/2;
  float p5x = (cos3d+3*sqrt3*sind+cosd*(-1+2*sqrt3*x*cosd-2*x*sind))/(2*sqrt3);
  float p5y = (-4+(-9+4*sqrt3*x*cosd)*cos2d+cos4d+(sqrt3+4*x*cosd)*sin2d+sqrt3*sin4d)/(12*cosd-4*sqrt3*sind);
    x2 = Px(6,delta)+xp;
  float p7x = (6*x2+4*sqrt3*cosd-sqrt3*cos3d+6*sind-4*sqrt3*x2*sin2d-3*sin3d)/12;
  float p7y = (-7*sqrt3-3*sqrt3*cos2d+6*x2*cos3d+sqrt3*cos4d+9*sin2d-2*sqrt3*x2*(-2*sind+sin3d)-3*sin4d)/(12*(sqrt3*cosd-sind));
  
  if (p2y < p3y) { p2y = p3y; p2x = p3x; }
  if (p5y > Py(4,delta)) { p5y = Py(4,delta); p5x = Px(4,delta); }
  if (x > p3x) { x = p3x; }
  if (x2 > p4x) { x2 = p4x; }
  
  if (p1x<Px(3,delta)) { //A1
    VerticesX[0]=Px(1,delta); VerticesX[1]=x; VerticesX[2]=p1x; VerticesX[3]=Px(2,delta);
    VerticesY[0]=Py(1,delta); VerticesY[1]=Py(1,delta); VerticesY[2]=p1y; VerticesY[3]=Py(2,delta);
    Areas[0] = PolygonArea(4); //(A_1)
  } else { //A1+A2 = A_1
    VerticesX[0]=Px(1,delta); VerticesX[1]=x; VerticesX[2]=p2x; VerticesX[3]=Px(3,delta); VerticesX[4]=Px(2,delta);
    VerticesY[0]=Py(1,delta); VerticesY[1]=Py(1,delta); VerticesY[2]=p2y; VerticesY[3]=Py(3,delta); VerticesY[4]=Py(2,delta);
    Areas[0] = PolygonArea(5); //(A_1)
  }
  if (x+(Px(6,delta)-Px(1,delta))<p4x) { //A1
    VerticesX[0]=Px(6,delta); VerticesX[1]=x+(Px(6,delta)-Px(1,delta)); VerticesX[2]=x; VerticesX[3]=Px(1,delta);
    VerticesY[0]=Py(6,delta); VerticesY[1]=Py(6,delta); VerticesY[2]=Py(1,delta); VerticesY[3]=Py(1,delta);
    Areas[1] = PolygonArea(4); //(A_2)
  } else { //A1+A2
    VerticesX[0]=Px(6,delta); VerticesX[1]=p4x; VerticesX[2]=p5x; VerticesX[3]=x; VerticesX[4]=Px(1,delta);
    VerticesY[0]=Py(6,delta); VerticesY[1]=p4y; VerticesY[2]=p5y; VerticesY[3]=Py(1,delta); VerticesY[4]=Py(1,delta);
    Areas[1] = PolygonArea(5); //(A_2)
  }
  VerticesX[0]=Px(6,delta); VerticesX[1]=Px(5,delta); VerticesX[2]=p7x; VerticesX[3]=x2; //A5
  VerticesY[0]=Py(6,delta); VerticesY[1]=Py(5,delta); VerticesY[2]=p7y; VerticesY[3]=Py(6,delta);
  Areas[2] = PolygonArea(4); //(A_3)
    
  return 0;
}

public float Px(int nii, float delta) {
  return -sin(delta - (nii-2)*PI/3);
}
public float Py(int nii, float delta) {
  return cos(delta - (nii-2)*PI/3);
}

public float PolygonArea(int nii) {
  float Area = VerticesX[nii-1]*VerticesY[0]-VerticesY[nii-1]*VerticesX[0];
  for (i=0; i<nii-1; i++) {
    Area = Area + VerticesX[i]*VerticesY[i+1]-VerticesY[i]*VerticesX[i+1];
  }
  return Area/2;
}

////Additional cosine factors as suggested by the article of Danny
//        if (CosToggle == true) { //exclude: 13, 14, 7, 11, 18, 5, 12
//          FresnelFactors[1]=FresnelFactors[1]*(cos11p/cos11)*(cos(phi12)/cos(phi12p));
//          FresnelFactors[3]=FresnelFactors[3]*(cos31p/cos31)*(cos(phi32)/cos(phi32p));
//          FresnelFactors[4]=FresnelFactors[4]*(cos(phi41p)/cos41)*(cos(phi42)/cos(phi42p));
//          FresnelFactors[20]=FresnelFactors[20]*(cos11p/cos11)*(cos(phi12)/cos(phi12p));
//          FresnelFactors[21]=FresnelFactors[21]*(cos(phi41p)/cos41)*(cos(phi42)/cos(phi42p));
//          FresnelFactors[22]=FresnelFactors[22]*(cos31p/cos31)*(cos(phi32)/cos(phi32p));
//          FresnelFactors[26]=FresnelFactors[26]*(cos(phi41p)/cos41)*(cos(phi42)/cos(phi42p));
//          FresnelFactors[27]=FresnelFactors[27]*(cos11p/cos11)*(cos(phi12)/cos(phi12p));
//          FresnelFactors[42]=FresnelFactors[42]*(cos31p/cos31)*(cos(phi32)/cos(phi32p));
//          FresnelFactors[41]=FresnelFactors[41]*(cos(phi41p)/cos41)*(cos(phi42)/cos(phi42p));
//          FresnelFactors[40]=FresnelFactors[40]*(cos11p/cos11)*(cos(phi12)/cos(phi12p));
//        }

//Key press events
public void keyPressed() {
  if (key == 'i') {
      ToggleI = !ToggleI; //pressing space bar
      theta0 = 0; //redo evaluation
  }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Halo" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
